# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetLoadTestMappingResult',
    'AwaitableGetLoadTestMappingResult',
    'get_load_test_mapping',
    'get_load_test_mapping_output',
]

@pulumi.output_type
class GetLoadTestMappingResult:
    """
    LoadTest mapping resource details
    """
    def __init__(__self__, azure_load_testing_resource_id=None, id=None, name=None, source_resource_id=None, system_data=None, test_id=None, type=None):
        if azure_load_testing_resource_id and not isinstance(azure_load_testing_resource_id, str):
            raise TypeError("Expected argument 'azure_load_testing_resource_id' to be a str")
        pulumi.set(__self__, "azure_load_testing_resource_id", azure_load_testing_resource_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if source_resource_id and not isinstance(source_resource_id, str):
            raise TypeError("Expected argument 'source_resource_id' to be a str")
        pulumi.set(__self__, "source_resource_id", source_resource_id)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if test_id and not isinstance(test_id, str):
            raise TypeError("Expected argument 'test_id' to be a str")
        pulumi.set(__self__, "test_id", test_id)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureLoadTestingResourceId")
    def azure_load_testing_resource_id(self) -> Optional[str]:
        """
        Mapped Azure Load Test resource Id.
        """
        return pulumi.get(self, "azure_load_testing_resource_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> Optional[str]:
        """
        Mapped source resource Id.
        """
        return pulumi.get(self, "source_resource_id")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="testId")
    def test_id(self) -> Optional[str]:
        """
        Mapped Azure Load Test resource test-id.
        """
        return pulumi.get(self, "test_id")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetLoadTestMappingResult(GetLoadTestMappingResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLoadTestMappingResult(
            azure_load_testing_resource_id=self.azure_load_testing_resource_id,
            id=self.id,
            name=self.name,
            source_resource_id=self.source_resource_id,
            system_data=self.system_data,
            test_id=self.test_id,
            type=self.type)


def get_load_test_mapping(load_test_mapping_name: Optional[str] = None,
                          resource_uri: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLoadTestMappingResult:
    """
    Get a LoadTestMappingResource


    :param str load_test_mapping_name: Load Test Mapping name
    :param str resource_uri: The fully qualified Azure Resource manager identifier of the resource.
    """
    __args__ = dict()
    __args__['loadTestMappingName'] = load_test_mapping_name
    __args__['resourceUri'] = resource_uri
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:loadtestservice/v20231201preview:getLoadTestMapping', __args__, opts=opts, typ=GetLoadTestMappingResult).value

    return AwaitableGetLoadTestMappingResult(
        azure_load_testing_resource_id=pulumi.get(__ret__, 'azure_load_testing_resource_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        source_resource_id=pulumi.get(__ret__, 'source_resource_id'),
        system_data=pulumi.get(__ret__, 'system_data'),
        test_id=pulumi.get(__ret__, 'test_id'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_load_test_mapping)
def get_load_test_mapping_output(load_test_mapping_name: Optional[pulumi.Input[str]] = None,
                                 resource_uri: Optional[pulumi.Input[str]] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetLoadTestMappingResult]:
    """
    Get a LoadTestMappingResource


    :param str load_test_mapping_name: Load Test Mapping name
    :param str resource_uri: The fully qualified Azure Resource manager identifier of the resource.
    """
    ...
