# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = ['LoadTestProfileMappingArgs', 'LoadTestProfileMapping']

@pulumi.input_type
class LoadTestProfileMappingArgs:
    def __init__(__self__, *,
                 resource_uri: pulumi.Input[str],
                 azure_load_testing_resource_id: Optional[pulumi.Input[str]] = None,
                 load_test_profile_mapping_name: Optional[pulumi.Input[str]] = None,
                 source_resource_id: Optional[pulumi.Input[str]] = None,
                 test_profile_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a LoadTestProfileMapping resource.
        :param pulumi.Input[str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        :param pulumi.Input[str] azure_load_testing_resource_id: Mapped Azure Load Test resource Id.
        :param pulumi.Input[str] load_test_profile_mapping_name: Load Test Profile Mapping name
        :param pulumi.Input[str] source_resource_id: Mapped source resource Id.
        :param pulumi.Input[str] test_profile_id: Mapped Azure Load Test resource test-profile-id.
        """
        pulumi.set(__self__, "resource_uri", resource_uri)
        if azure_load_testing_resource_id is not None:
            pulumi.set(__self__, "azure_load_testing_resource_id", azure_load_testing_resource_id)
        if load_test_profile_mapping_name is not None:
            pulumi.set(__self__, "load_test_profile_mapping_name", load_test_profile_mapping_name)
        if source_resource_id is not None:
            pulumi.set(__self__, "source_resource_id", source_resource_id)
        if test_profile_id is not None:
            pulumi.set(__self__, "test_profile_id", test_profile_id)

    @property
    @pulumi.getter(name="resourceUri")
    def resource_uri(self) -> pulumi.Input[str]:
        """
        The fully qualified Azure Resource manager identifier of the resource.
        """
        return pulumi.get(self, "resource_uri")

    @resource_uri.setter
    def resource_uri(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_uri", value)

    @property
    @pulumi.getter(name="azureLoadTestingResourceId")
    def azure_load_testing_resource_id(self) -> Optional[pulumi.Input[str]]:
        """
        Mapped Azure Load Test resource Id.
        """
        return pulumi.get(self, "azure_load_testing_resource_id")

    @azure_load_testing_resource_id.setter
    def azure_load_testing_resource_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "azure_load_testing_resource_id", value)

    @property
    @pulumi.getter(name="loadTestProfileMappingName")
    def load_test_profile_mapping_name(self) -> Optional[pulumi.Input[str]]:
        """
        Load Test Profile Mapping name
        """
        return pulumi.get(self, "load_test_profile_mapping_name")

    @load_test_profile_mapping_name.setter
    def load_test_profile_mapping_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "load_test_profile_mapping_name", value)

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> Optional[pulumi.Input[str]]:
        """
        Mapped source resource Id.
        """
        return pulumi.get(self, "source_resource_id")

    @source_resource_id.setter
    def source_resource_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_resource_id", value)

    @property
    @pulumi.getter(name="testProfileId")
    def test_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Mapped Azure Load Test resource test-profile-id.
        """
        return pulumi.get(self, "test_profile_id")

    @test_profile_id.setter
    def test_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "test_profile_id", value)


class LoadTestProfileMapping(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 azure_load_testing_resource_id: Optional[pulumi.Input[str]] = None,
                 load_test_profile_mapping_name: Optional[pulumi.Input[str]] = None,
                 resource_uri: Optional[pulumi.Input[str]] = None,
                 source_resource_id: Optional[pulumi.Input[str]] = None,
                 test_profile_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        LoadTest profile mapping resource details

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] azure_load_testing_resource_id: Mapped Azure Load Test resource Id.
        :param pulumi.Input[str] load_test_profile_mapping_name: Load Test Profile Mapping name
        :param pulumi.Input[str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        :param pulumi.Input[str] source_resource_id: Mapped source resource Id.
        :param pulumi.Input[str] test_profile_id: Mapped Azure Load Test resource test-profile-id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: LoadTestProfileMappingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        LoadTest profile mapping resource details

        :param str resource_name: The name of the resource.
        :param LoadTestProfileMappingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(LoadTestProfileMappingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 azure_load_testing_resource_id: Optional[pulumi.Input[str]] = None,
                 load_test_profile_mapping_name: Optional[pulumi.Input[str]] = None,
                 resource_uri: Optional[pulumi.Input[str]] = None,
                 source_resource_id: Optional[pulumi.Input[str]] = None,
                 test_profile_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = LoadTestProfileMappingArgs.__new__(LoadTestProfileMappingArgs)

            __props__.__dict__["azure_load_testing_resource_id"] = azure_load_testing_resource_id
            __props__.__dict__["load_test_profile_mapping_name"] = load_test_profile_mapping_name
            if resource_uri is None and not opts.urn:
                raise TypeError("Missing required property 'resource_uri'")
            __props__.__dict__["resource_uri"] = resource_uri
            __props__.__dict__["source_resource_id"] = source_resource_id
            __props__.__dict__["test_profile_id"] = test_profile_id
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:loadtestservice:LoadTestProfileMapping")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(LoadTestProfileMapping, __self__).__init__(
            'azure-native:loadtestservice/v20231201preview:LoadTestProfileMapping',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'LoadTestProfileMapping':
        """
        Get an existing LoadTestProfileMapping resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = LoadTestProfileMappingArgs.__new__(LoadTestProfileMappingArgs)

        __props__.__dict__["azure_load_testing_resource_id"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["source_resource_id"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["test_profile_id"] = None
        __props__.__dict__["type"] = None
        return LoadTestProfileMapping(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureLoadTestingResourceId")
    def azure_load_testing_resource_id(self) -> pulumi.Output[Optional[str]]:
        """
        Mapped Azure Load Test resource Id.
        """
        return pulumi.get(self, "azure_load_testing_resource_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> pulumi.Output[Optional[str]]:
        """
        Mapped source resource Id.
        """
        return pulumi.get(self, "source_resource_id")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="testProfileId")
    def test_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        Mapped Azure Load Test resource test-profile-id.
        """
        return pulumi.get(self, "test_profile_id")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

