# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AssociationSubnetResponse',
    'ResourceIdResponse',
    'SecurityPolicyConfigurationsResponse',
    'SystemDataResponse',
    'WafPolicyResponse',
    'WafSecurityPolicyResponse',
]

@pulumi.output_type
class AssociationSubnetResponse(dict):
    """
    Association Subnet.
    """
    def __init__(__self__, *,
                 id: str):
        """
        Association Subnet.
        :param str id: Association ID.
        """
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Association ID.
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class ResourceIdResponse(dict):
    """
    Resource ID definition used by parent to reference child resources.
    """
    def __init__(__self__, *,
                 id: str):
        """
        Resource ID definition used by parent to reference child resources.
        :param str id: Resource ID of child resource.
        """
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Resource ID of child resource.
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class SecurityPolicyConfigurationsResponse(dict):
    """
    SecurityPolicyConfigurations Subresource of Traffic Controller.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "wafSecurityPolicy":
            suggest = "waf_security_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SecurityPolicyConfigurationsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SecurityPolicyConfigurationsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SecurityPolicyConfigurationsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 waf_security_policy: Optional['outputs.WafSecurityPolicyResponse'] = None):
        """
        SecurityPolicyConfigurations Subresource of Traffic Controller.
        :param 'WafSecurityPolicyResponse' waf_security_policy: Contains reference to a WAF-type security policy that is applied at the Traffic Controller level.
        """
        if waf_security_policy is not None:
            pulumi.set(__self__, "waf_security_policy", waf_security_policy)

    @property
    @pulumi.getter(name="wafSecurityPolicy")
    def waf_security_policy(self) -> Optional['outputs.WafSecurityPolicyResponse']:
        """
        Contains reference to a WAF-type security policy that is applied at the Traffic Controller level.
        """
        return pulumi.get(self, "waf_security_policy")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 created_by: Optional[str] = None,
                 created_by_type: Optional[str] = None,
                 last_modified_at: Optional[str] = None,
                 last_modified_by: Optional[str] = None,
                 last_modified_by_type: Optional[str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param str created_at: The timestamp of resource creation (UTC).
        :param str created_by: The identity that created the resource.
        :param str created_by_type: The type of identity that created the resource.
        :param str last_modified_at: The timestamp of resource last modification (UTC)
        :param str last_modified_by: The identity that last modified the resource.
        :param str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


@pulumi.output_type
class WafPolicyResponse(dict):
    """
    Web Application Firewall Policy
    """
    def __init__(__self__, *,
                 id: str):
        """
        Web Application Firewall Policy
        :param str id: Resource ID of the WAF
        """
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Resource ID of the WAF
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class WafSecurityPolicyResponse(dict):
    """
    Web Application Firewall Security Policy
    """
    def __init__(__self__, *,
                 id: str):
        """
        Web Application Firewall Security Policy
        :param str id: Resource ID of the Waf Security Policy
        """
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Resource ID of the Waf Security Policy
        """
        return pulumi.get(self, "id")


